ctest(1)

NAME

  ctest - Testing driver provided by CMake.

SYNOPSIS

  ctest [options]

DESCRIPTION

The "ctest" executable is the CMake test driver program. CMake-generated build trees created for projects that use the ENABLE_TESTING and ADD_TEST commands have testing support. This program will run the tests and report results.

CMake is a cross-platform build system generator. Projects specify their build process with platform-independent CMake listfiles included in each directory of a source tree with the name CMakeLists.txt. Users build a project by using CMake to generate a build system for a native tool on their platform.

OPTIONS

-C <config>
    Choose configuration to test. Some CMake-generated build trees can have multiple build configurations in the same tree. This option can be used to specify which one should be tested. Example configurations are "Debug" and "Release".

-V,--verbose
    Enable verbose output from tests. Test output is normally suppressed and only summary information is displayed. This option will show all test output.

-N,--show-only
    Disable actual execution of tests. This option tells ctest to list the tests that would be run but not actually run them. Useful in conjunction with the -R and -E options.

-R <regex>
    Run tests matching regular expression. This option tells ctest to run only the tests whose names match the given regular expression.

-E <regex>
    Exclude tests matching regular expression. This option tells ctest to NOT run the tests whose names match the given regular expression.

-D <DashboardTest>
    Execute dashboard test This option tells ctest to perform act as a Dart client and perform a dashboard test. All tests are ModeTest, where Mode can be Experimental, Nightly, and Continuous, and Test can be Start, Update, Configure, Build, Test, Coverage, and Submit.

-S <ConfigScript>
    Execute a dashboard for a configuration This option tells ctest to load in a configuration script which sets a number of parameters such as the binary and source directories. Then ctest will do what is required to create and run a dashboard. This option basically sets up a dashboard and then runs ctest -D with the appropriate options.

-A <Notes file>
    Add a notes file with submission This option tells ctest to include a notes file when submitting dashboard.

-I [Start,End,Stride,test#,test#|Test file]
    Run a specific number of tests by number. This option causes ctest to run tests starting at number Start, ending at number End, and incrementing by Stride. Any additional numbers after Stride are considered individual test numbers. Start, End,or stride can be empty. Optionally a file can be given that contains the same syntax as the command line.

--interactive-debug-mode [0|1]
    Set the interactive mode to 0 or 1. This option causes ctest to run tests in either an interactive mode or a non-interactive mode. On Windows this means that in non-interactive mode, all system debug pop up windows are blocked. In dashboard mode (Experimental, Nightly, Continuous), the default is non-interactive. When just running tests not for a dashboard the default is to allow popups and interactive debugging.

--build-and-test
    Build and run a test. This option allows a test to be compiled and then run. CMake is run on the source tree and then based on the generator the build is run. The arguments to this command line are the source and binary directories. Other options that affect this mode are --build-target --build-nocmake, --build-run-dir, --build-two-config, --build-exe-dir, --build-generator, --build-project,--build-makeprogram --build-noclean, --build-options

--build-target
    Specify a specific target to build. This option goes with the --build-and-test option, if left out the all target is built.

--build-nocmake
    Run the build without running cmake first. Skip the cmake step.

--build-run-dir
    Specify directory to run programs from. Directory where programs will be after it has been compiled.

--build-two-config
    Run CMake twice

--build-exe-dir
    Specify the directory for the executable.

--build-generator
    Specify the generator to use.

--build-project
    Specify the name of the project to build.

--build-makeprogram
    Specify the make program to use.

--build-noclean
    Skip the make clean step.

--build-options
    Add extra options to the build step.

--tomorrow-tag
    Nightly or experimental starts with next day tag. This is useful if the build will not finish in one day.

--copyright [file]
    Print the CMake copyright and exit. If a file is specified, the copyright is written into it.

--help
    Print usage information and exit. Usage describes the basic command line interface and its options.

--help-full [file]
    Print full help and exit. Full help displays most of the documentation provided by the UNIX man page. It is provided for use on non-UNIX platforms, but is also convenient if the man page is not installed. If a file is specified, the help is written into it.

--help-html [file]
    Print full help in HTML format. This option is used by CMake authors to help produce web pages. If a file is specified, the help is written into it.

--help-man [file]
    Print a UNIX man page and exit. This option is used by the cmake build to generate the UNIX man page. If a file is specified, the help is written into it.

--version [file]
    Show program name/version banner and exit. If a file is specified, the version is written into it.

COPYRIGHT

Copyright (c) 2002 Kitware, Inc., Insight Consortium. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

*   Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

*   Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

*   The names of Kitware, Inc., the Insight Consortium, or the names of any consortium members, or of any contributors, may not be used to endorse or promote products derived from this software without specific prior written permission.

*   Modified source versions must be plainly marked as such, and must not be misrepresented as being the original software.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

MAILING LIST

For help and discussion about using cmake, a mailing list is provided at cmake@www.cmake.org. Please first read the full documentation at http://www.cmake.org before posting questions to the list.

SEE ALSO

cmake(1), ccmake(1)

AUTHOR

This manual page was generated by the "--help-man" option.